<?php
$after = '';
	if ( class_exists( 'WooCommerce' ) ) :
	if (YSettings::g("woocommerce_dynamic_cart", "1") == "1") {
		global $woocommerce;
		if($woocommerce->cart->cart_contents_count == 0) {
			$count = '<sup><span class="shipping-cart-count">'.$woocommerce->cart->cart_contents_count.'</span></sup>';
		} else {
			$count = '<sup><span class="shipping-cart-count">'.$woocommerce->cart->cart_contents_count.'</span></sup>';
		}
		$after .= '<li class="shopping-cart space-left"><a href="'.$woocommerce->cart->get_cart_url().'" class="cart"><i class="icon-bag"></i>'.$count.'</a>';
		$after .= '<ul class="show-cart">';
	
		if ( sizeof( $woocommerce->cart->cart_contents ) == 0 ) {
			$after .= '<li class="product">'. __( 'Your cart is currently empty.', 'BERG').'</li>';
		} else {
			foreach ( WC()->cart->get_cart() as $cart_item_key => $cart_item ) {
				$_product     = apply_filters( 'woocommerce_cart_item_product', $cart_item['data'], $cart_item, $cart_item_key );
				$product_id   = apply_filters( 'woocommerce_cart_item_product_id', $cart_item['product_id'], $cart_item, $cart_item_key );

				if ($_product->is_sold_individually()) {
					$product_quantity = "1";
				} else {
					$product_quantity = $cart_item['quantity'];
				}

				$thumb_url = wp_get_attachment_image_src( get_post_thumbnail_id($product_id), 'menu_thumb' );
				
				if(empty($thumb_url)) {
					$thumb_url = THEME_DIR_URI.'/img/placeholder.png';
				} else {
					$thumb_url = $thumb_url[0];
				}
				$after .= '<li class="product">
					<a href="'.$_product->get_permalink().'" class="img-product">
						<figure><img src="'.$thumb_url.'" alt="" /></figure>
					</a>

					<div class="list-product">
						<a href="' . $_product->get_permalink() . '"><h5>' . $_product->get_title() . '</h5></a>
						<div class="quantity buttons_added header-font-family">' . $product_quantity . '</div>
						<div class="price-product header-font-family">' . strip_tags(WC()->cart->get_product_price( $_product )) . '</div>
						<a class="remove-product" title="'.__( 'Remove this item', 'BERG').'" href="'.esc_url( WC()->cart->get_remove_url( $cart_item_key ) ).'"><i class="icon-close"></i></a>
					</div>
				</li>';
			}

			// subtotal
			$cart_url = $woocommerce->cart->get_cart_url();
			$checkout_url = $woocommerce->cart->get_checkout_url();

			$after .= '<li class="summation">
				<div class="summation-subtotal">
					<span>'.__('Subtotal', 'woocommerce').':</span>
					<span class="amount header-font-family">' . WC()->cart->get_cart_subtotal() . '</span>
				</div>
				<div class="btn-cart">
					<a class="btn btn-sm btn-default" href="'.$cart_url.'">'.__('View Cart', 'woocommerce').'</a>
					<a class="btn btn-sm btn-dark" href="'.$checkout_url.'">'.__('Checkout', 'woocommerce').'</a>
				</div>
			</li>';
			}
		$after .= '</ul></li>';
	}
	endif;
?>

<?php
	$navType = 2;
	$colorClass = '';

	$postLight = false;
	if(is_singular('post') && (YSettings::g('post_template') == 'post_template_2' || (YSettings::g('berg_post_template') == '2' && YSettings::g('post_template') == 'default' ))) {
		$postLight = true;
	}


	if(YSettings::g('navigation_text_color') != 'default' && YSettings::g('navigation_text_color') !='' ) {
		$colorClass = 'nav-'.YSettings::g('navigation_text_color');
	} else {
		if(berg_getIntro() !== false || is_page_template('team.php') || is_page_template('homepage2.php') || is_page_template('homepage.php') || is_page_template('restaurant.php') || is_page_template('contact2.php') || $postLight == true ) {
			$colorClass = 'nav-light';
		} else {
			$colorClass = 'nav-dark';
		}
	}

	$navId = 'main-navbar';
	$depth = 2;
	if($navType == 2) {
		$depth = 3;
		$navId = 'main-navbar-home';
		$colorClass .= ' second-navbar nav-third';
	}
?>
	<nav id="<?php echo $navId; ?>" class="hidden-xs hidden-sm <?php echo $colorClass; ?>" >
		<div class="nav hidden-xs">
	

			<div class="logo">
				<a href="<?php echo home_url(); ?>">
					<figure class="static-logo">
						<?php

						if(YSettings::g('navigation_text_color') == 'default') {
							if(berg_getIntro() !== false || is_page_template('team.php') || is_page_template('homepage.php') || is_page_template('restaurant.php') || is_page_template('contact2.php') || $postLight == true) {
								$logo = YSettings::g('logo_image_light');
							} else {
								$logo = YSettings::g('logo_image_dark');	
							}
						} else {
							$logo = YSettings::g('logo_image_'.YSettings::g('navigation_text_color'));
						}

						
						if(isset($logo['url']) && $logo['url'] != '') : ?>
						<img src="<?php echo $logo['url']; ?>" class="" alt="<?php bloginfo('name'); ?>" />
						<?php endif; ?>
					</figure>
				</a>
			</div>

			<?php 
			if (has_nav_menu('primary')) {
				wp_nav_menu(array(
					'theme_location' => 'primary',
					'depth'=>$depth,
					'container_class' => 'main-nav bg-opacity-'.$classesNav,
					'walker' => new Child_Wrap(),
					'items_wrap' => '<ul id="%1$s" class="%2$s hidden-xs hidden-sm">%3$s</ul>',
				));
			}
			?>

			<div class="nav-third-additional">
				<ul>
					<?php echo get_nav_social_profiles(); ?>
					<?php echo $after; ?>
					<?php do_action('wpml_add_language_selector'); ?>
				</ul>
			</div>

		</div>
	</nav>